Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1686)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Revised calculation of Obukhov length. Added output of radiative heating >
+! rates for RRTMG.
 ! 
 ! Former revisions:
@@ -161,8 +162,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  ddzu, ddzw, e, hyp, km, kh, nr, p, prho, pt, q, qc, ql, qr, qs, &
-               qsws, qswst, rho, sa, saswsb, saswst, shf, td_lsa_lpt, td_lsa_q,&
-               td_sub_lpt, td_sub_q, time_vert, ts, tswst, u, ug, us, usws,    &
-               uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
+        ONLY:  ddzu, ddzw, e, hyp, km, kh, nr, ol, p, prho, pt, q, qc, ql, qr, &
+               qs, qsws, qswst, rho, sa, saswsb, saswst, shf, td_lsa_lpt,      &
+               td_lsa_q, td_sub_lpt, td_sub_q, time_vert, ts, tswst, u, ug, us,& 
+               usws, uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
         
     USE cloud_parameters,                                                      &
@@ -172,6 +173,6 @@
         ONLY:   average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
                 dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
-                large_scale_subsidence, max_pr_user, message_string, ocean,    &
-                passive_scalar, precipitation, simulated_time,                 &
+                large_scale_subsidence, max_pr_user, message_string, neutral,  &
+                ocean, passive_scalar, precipitation, simulated_time,          &
                 use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
                 ws_scheme_mom, ws_scheme_sca
@@ -199,5 +200,6 @@
     USE radiation_model_mod,                                                   &
         ONLY:  dots_rad, radiation, radiation_scheme, rad_net,                 &
-               rad_lw_in, rad_lw_out, rad_sw_in, rad_sw_out
+               rad_lw_in, rad_lw_out, rad_lw_cs_hr, rad_lw_hr,                 &
+               rad_sw_in, rad_sw_out, rad_sw_cs_hr, rad_sw_hr
 
 #if defined ( __rrtmg )
@@ -207,4 +209,5 @@
   
     USE statistics
+
 
     IMPLICIT NONE
@@ -240,5 +243,5 @@
     CALL cpu_log( log_point(10), 'flow_statistics', 'start' )
 
-    !$acc update host( km, kh, e, pt, qs, qsws, rif, shf, ts, u, usws, v, vsws, w )
+    !$acc update host( km, kh, e, ol, pt, qs, qsws, shf, ts, u, usws, v, vsws, w )
 
 !
@@ -744,13 +747,19 @@
 !
 !--                   Formula does not work if ql(nzb) /= 0.0
-                      sums_l(nzb,51,tn) = sums_l(nzb,51,tn) + &   ! w"q" (w"qv")
-                                          qsws(j,i) * rmask(j,i,sr)
+                      sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  & 
+                                          qsws(j,i) * rmask(j,i,sr) ! w"q" (w"qv")
                    ENDIF
                 ENDIF
                 IF ( passive_scalar )  THEN
-                   sums_l(nzb,48,tn) = sums_l(nzb,48,tn) + &
-                                       qsws(j,i) * rmask(j,i,sr)  ! w"q" (w"qv")
+                   sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
+                                       qsws(j,i) * rmask(j,i,sr) ! w"q" (w"qv")
                 ENDIF
              ENDIF
+
+             IF ( .NOT. neutral )  THEN
+                sums_l(nzb,114,tn) = sums_l(nzb,114,tn) +                      &
+                                    ol(j,i)  * rmask(j,i,sr) ! L
+             ENDIF
+
 
              IF ( land_surface )  THEN
@@ -774,8 +783,8 @@
 #if defined ( __rrtmg )
                 IF ( radiation_scheme == 'rrtmg' )  THEN
-                   sums_l(nzb,106,tn)  = sums_l(nzb,106,tn)  + rrtm_aldif(0,j,i)
-                   sums_l(nzb,107,tn)  = sums_l(nzb,107,tn)  + rrtm_aldir(0,j,i)
-                   sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  + rrtm_asdif(0,j,i)
-                   sums_l(nzb,109,tn)  = sums_l(nzb,109,tn)  + rrtm_asdir(0,j,i)
+                   sums_l(nzb,110,tn)  = sums_l(nzb,110,tn)  + rrtm_aldif(0,j,i)
+                   sums_l(nzb,111,tn)  = sums_l(nzb,111,tn)  + rrtm_aldir(0,j,i)
+                   sums_l(nzb,112,tn)  = sums_l(nzb,112,tn)  + rrtm_asdif(0,j,i)
+                   sums_l(nzb,113,tn)  = sums_l(nzb,113,tn)  + rrtm_asdir(0,j,i)
                 ENDIF
 #endif
@@ -997,6 +1006,6 @@
 !--    First calculate the products, then the divergence.
 !--    Calculation is time consuming. Do it only, if profiles shall be plotted.
-       IF ( hom(nzb+1,2,55,0) /= 0.0_wp  .OR.  hom(nzb+1,2,68,0) /= 0.0_wp )  THEN
-
+       IF ( hom(nzb+1,2,55,0) /= 0.0_wp  .OR.  hom(nzb+1,2,68,0) /= 0.0_wp )   &
+       THEN
           sums_ll = 0.0_wp  ! local array
 
@@ -1037,6 +1046,6 @@
 !
 !--    Divergence of vertical flux of SGS TKE and the flux itself (69)
-       IF ( hom(nzb+1,2,57,0) /= 0.0_wp  .OR.  hom(nzb+1,2,69,0) /= 0.0_wp )  THEN
-
+       IF ( hom(nzb+1,2,57,0) /= 0.0_wp  .OR.  hom(nzb+1,2,69,0) /= 0.0_wp )   &
+       THEN
           !$OMP DO
           DO  i = nxl, nxr
@@ -1109,5 +1118,5 @@
 !--    Collect current large scale advection and subsidence tendencies for
 !--    data output
-       IF ( large_scale_forcing  .AND.  ( simulated_time .GT. 0.0_wp ) )  THEN
+       IF ( large_scale_forcing  .AND.  ( simulated_time > 0.0_wp ) )  THEN
 !
 !--       Interpolation in time of LSF_DATA 
@@ -1156,6 +1165,8 @@
              DO  j =  nys, nyn
                 DO  k = nzb_soil, nzt_soil
-                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i)         &
+                                      * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i)         &
+                                      * rmask(j,i,sr)
                 ENDDO
              ENDDO
@@ -1168,8 +1179,20 @@
              DO  j =  nys, nyn
                 DO  k = nzb_s_inner(j,i)+1, nzt+1
-                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i)   &
+                                       * rmask(j,i,sr)
+                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i)   &
+                                       * rmask(j,i,sr)
+                   sums_l(k,106,tn)  = sums_l(k,106,tn)  + rad_lw_cs_hr(k,j,i) &
+                                       * rmask(j,i,sr)
+                   sums_l(k,107,tn)  = sums_l(k,107,tn)  + rad_lw_hr(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,108,tn)  = sums_l(k,108,tn)  + rad_sw_cs_hr(k,j,i) &
+                                       * rmask(j,i,sr)
+                   sums_l(k,109,tn)  = sums_l(k,108,tn)  + rad_sw_hr(k,j,i)    &
+                                       * rmask(j,i,sr)
                 ENDDO
              ENDDO
@@ -1374,14 +1397,22 @@
           hom(:,1,105,sr) = sums(:,105)            ! rad_sw_out
 
+          IF ( radiation_scheme == 'rrtmg' )  THEN
+             hom(:,1,106,sr) = sums(:,106)            ! rad_lw_cs_hr
+             hom(:,1,107,sr) = sums(:,107)            ! rad_lw_hr
+             hom(:,1,108,sr) = sums(:,108)            ! rad_sw_cs_hr
+             hom(:,1,109,sr) = sums(:,109)            ! rad_sw_hr
+
 #if defined ( __rrtmg )
-          IF ( radiation_scheme == 'rrtmg' )  THEN
-             hom(:,1,106,sr) = sums(:,106)            ! rrtm_aldif
-             hom(:,1,107,sr) = sums(:,107)            ! rrtm_aldir
-             hom(:,1,108,sr) = sums(:,108)            ! rrtm_asdif
-             hom(:,1,109,sr) = sums(:,109)            ! rrtm_asdir
+             hom(:,1,110,sr) = sums(:,110)            ! rrtm_aldif
+             hom(:,1,111,sr) = sums(:,111)            ! rrtm_aldir
+             hom(:,1,112,sr) = sums(:,112)            ! rrtm_asdif
+             hom(:,1,113,sr) = sums(:,113)            ! rrtm_asdir
+#endif
           ENDIF
-#endif
-
-       ENDIF
+
+
+       ENDIF
+
+       hom(:,1,114,sr) = sums(:,114)            !: L
 
        hom(:,1,pr_palm-1,sr) = sums(:,pr_palm-1)
@@ -1520,8 +1551,14 @@
        ts_value(20,sr) = hom(nzb+2,1,pr_palm,sr)    ! v'w'    at k=0
        ts_value(21,sr) = hom(nzb,1,48,sr)           ! w"q"    at k=0
-
+ 
+!
+!--    Calculate obukhov length
        IF ( ts_value(5,sr) /= 0.0_wp )  THEN
-          ts_value(22,sr) = ts_value(4,sr)**2 / &
-                            ( kappa * g * ts_value(5,sr) / ts_value(18,sr) ) ! L
+!           IF ( most_method == 'circular' )  THEN
+!              ts_value(22,sr) = ts_value(4,sr)**2 /                             &
+!                           ( kappa * g * ts_value(5,sr) / ts_value(18,sr) ) 
+!           ELSE
+             ts_value(22,sr) = hom(nzb,1,114,sr)  
+!          ENDIF     
        ELSE
           ts_value(22,sr) = 10000.0_wp
@@ -1553,8 +1590,8 @@
 #if defined ( __rrtmg )
           IF ( radiation_scheme == 'rrtmg' )  THEN
-             ts_value(dots_rad+5,sr) = hom(nzb,1,106,sr)          ! rrtm_aldif
-             ts_value(dots_rad+6,sr) = hom(nzb,1,107,sr)          ! rrtm_aldir
-             ts_value(dots_rad+7,sr) = hom(nzb,1,108,sr)          ! rrtm_asdif
-             ts_value(dots_rad+8,sr) = hom(nzb,1,109,sr)          ! rrtm_asdir
+             ts_value(dots_rad+5,sr) = hom(nzb,1,110,sr)          ! rrtm_aldif
+             ts_value(dots_rad+6,sr) = hom(nzb,1,111,sr)          ! rrtm_aldir
+             ts_value(dots_rad+7,sr) = hom(nzb,1,112,sr)          ! rrtm_asdif
+             ts_value(dots_rad+8,sr) = hom(nzb,1,113,sr)          ! rrtm_asdir
           ENDIF
 #endif
@@ -1642,5 +1679,6 @@
 #if defined ( __rrtmg )
     USE radiation_model_mod,                                                   &
-        ONLY:  rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir
+        ONLY:  rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir, rad_lw_cs_hr,   &
+               rad_lw_hr,  rad_sw_cs_hr, rad_sw_hr
 #endif
 
@@ -3063,5 +3101,5 @@
 !--    Collect current large scale advection and subsidence tendencies for
 !--    data output
-       IF ( large_scale_forcing  .AND.  ( simulated_time .GT. 0.0_wp ) )  THEN
+       IF ( large_scale_forcing  .AND.  ( simulated_time > 0.0_wp ) )  THEN
 !
 !--       Interpolation in time of LSF_DATA 
@@ -3110,6 +3148,8 @@
              DO  j =  nys, nyn
                 DO  k = nzb_soil, nzt_soil
-                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i)         &
+                                      * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i)         &
+                                      * rmask(j,i,sr)
                 ENDDO
              ENDDO
@@ -3123,8 +3163,22 @@
              DO  j =  nys, nyn
                 DO  k = nzb_s_inner(j,i)+1, nzt+1
-                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i)   &
+                                       * rmask(j,i,sr)
+                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i)   &
+                                       * rmask(j,i,sr)
+#if defined ( __rrtmg )
+                   sums_l(k,106,tn)  = sums_l(k,106,tn)  + rad_lw_cs_hr(k,j,i) &
+                                       * rmask(j,i,sr)
+                   sums_l(k,107,tn)  = sums_l(k,107,tn)  + rad_lw_hr(k,j,i)    &
+                                       * rmask(j,i,sr)
+                   sums_l(k,108,tn)  = sums_l(k,108,tn)  + rad_sw_cs_hr(k,j,i) &
+                                       * rmask(j,i,sr)
+                   sums_l(k,109,tn)  = sums_l(k,109,tn)  + rad_sw_hr(k,j,i)    &
+                                       * rmask(j,i,sr)
+#endif
                 ENDDO
              ENDDO
@@ -3193,6 +3247,7 @@
           sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
           sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
-          sums(k,89:105)           = sums(k,89:105)     / ngp_2dh(sr)
-          sums(k,106:pr_palm-2)    = sums(k,106:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,89:114)           = sums(k,89:114)     / ngp_2dh(sr)
+          sums(k,115:pr_palm-2)    = sums(k,115:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+
        ENDDO
 
@@ -3446,6 +3501,5 @@
 
        IF ( ts_value(5,sr) /= 0.0_wp )  THEN
-          ts_value(22,sr) = ts_value(4,sr)**2_wp / &
-                            ( kappa * g * ts_value(5,sr) / ts_value(18,sr) ) ! L
+          ts_value(22,sr) = hom(nzb,1,114,sr)
        ELSE
           ts_value(22,sr) = 10000.0_wp
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1686)
+++ palm/trunk/SOURCE/header.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Renamed prandtl_layer to constant_flux_layer, renames rif_min/rif_max to
+! zeta_min/zeta_max.
 ! 
 ! Former revisions:
@@ -1118,8 +1119,8 @@
     ENDIF
 
-    IF ( prandtl_layer )  THEN
-       WRITE ( io, 305 )  (zu(1)-zu(0)), roughness_length, &
-                          z0h_factor*roughness_length, kappa, &
-                          rif_min, rif_max
+    IF ( constant_flux_layer )  THEN
+       WRITE ( io, 305 )  (zu(1)-zu(0)), roughness_length,                     &
+                          z0h_factor*roughness_length, kappa,                  &
+                          zeta_min, zeta_max
        IF ( .NOT. constant_heatflux )  WRITE ( io, 308 )
        IF ( humidity  .AND.  .NOT. constant_waterflux )  THEN
@@ -1131,5 +1132,5 @@
     ELSE
        IF ( INDEX(initializing_actions, 'set_1d-model_profiles') /= 0 )  THEN
-          WRITE ( io, 310 )  rif_min, rif_max
+          WRITE ( io, 310 )  zeta_min, zeta_max
        ENDIF
     ENDIF
Index: palm/trunk/SOURCE/init_1d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_1d_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/init_1d_model.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Renamed prandtl_layer to constant_flux_layer. rif is replaced by ol and zeta.
 ! 
 ! Former revisions:
@@ -72,4 +72,6 @@
 !> of the wind profile is being computed.
 !> All subroutines required can be found within this file.
+!>
+!> @todo harmonize code with new surface_layer_fluxes module
 !------------------------------------------------------------------------------!
  SUBROUTINE init_1d_model
@@ -90,8 +92,7 @@
     
     USE control_parameters,                                                    &
-        ONLY:  constant_diffusion, f, humidity, kappa, km_constant,            &
-               mixing_length_1d, passive_scalar, prandtl_layer,                &
-               prandtl_number, roughness_length, simulated_time_chr,           &
-               z0h_factor
+        ONLY:  constant_diffusion, constant_flux_layer, f, humidity, kappa,    &
+               km_constant, mixing_length_1d, passive_scalar, prandtl_number,  &
+               roughness_length, simulated_time_chr, z0h_factor
 
     IMPLICIT NONE
@@ -166,5 +167,5 @@
 !
 !-- For u*, theta* and the momentum fluxes plausible values are set
-    IF ( prandtl_layer )  THEN
+    IF ( constant_flux_layer )  THEN
        us1d = 0.1_wp   ! without initial friction the flow would not change
     ELSE
@@ -213,9 +214,9 @@
         
     USE control_parameters,                                                    &
-        ONLY:  constant_diffusion, dissipation_1d, humidity,                   &
-               intermediate_timestep_count, intermediate_timestep_count_max,   &
-               f, g, ibc_e_b, kappa, mixing_length_1d, passive_scalar,         &
-               prandtl_layer, rif_max, rif_min, simulated_time_chr,            &
-               timestep_scheme, tsc
+        ONLY:  constant_diffusion, constant_flux_layer, dissipation_1d,        &
+               humidity, intermediate_timestep_count,                          &
+               intermediate_timestep_count_max, f, g, ibc_e_b, kappa,          &  
+               mixing_length_1d, passive_scalar,                               &
+               simulated_time_chr, timestep_scheme, tsc, zeta_max, zeta_min
                 
     USE indices,                                                               &
@@ -334,5 +335,5 @@
 !--       Finite differences of the momentum fluxes are computed using half the 
 !--       normal grid length (2.0*ddzw(k)) for the sake of enhanced accuracy 
-          IF ( prandtl_layer )  THEN
+          IF ( constant_flux_layer )  THEN
 
              k = nzb+1
@@ -465,5 +466,5 @@
 !
 !--          First compute the vertical fluxes in the Prandtl-layer
-             IF ( prandtl_layer )  THEN
+             IF ( constant_flux_layer )  THEN
 !
 !--             Compute theta* using Rif numbers of the previous time step
@@ -498,5 +499,5 @@
                 ENDIF
 
-             ENDIF    ! prandtl_layer
+             ENDIF    ! constant_flux_layer
 
 !
@@ -506,5 +507,5 @@
 !--          the rif-numbers of the previous time step are used.
 
-             IF ( prandtl_layer )  THEN
+             IF ( constant_flux_layer )  THEN
                 IF ( .NOT. humidity )  THEN
                    pt_0 = pt_init(nzb+1)
@@ -547,10 +548,10 @@
 !--          range. It is exceeded excessively for very small velocities
 !--          (u,v --> 0).
-             WHERE ( rif1d < rif_min )  rif1d = rif_min
-             WHERE ( rif1d > rif_max )  rif1d = rif_max
+             WHERE ( rif1d < zeta_min )  rif1d = zeta_min
+             WHERE ( rif1d > zeta_max )  rif1d = zeta_max
 
 !
 !--          Compute u* from the absolute velocity value
-             IF ( prandtl_layer )  THEN
+             IF ( constant_flux_layer )  THEN
                 uv_total = SQRT( u1d(nzb+1)**2 + v1d(nzb+1)**2 )
 
@@ -639,5 +640,5 @@
                 ENDIF             
 
-             ENDIF   !  prandtl_layer
+             ENDIF   !  constant_flux_layer
 
 !
@@ -673,5 +674,5 @@
 !--          computed via the adiabatic mixing length, for the unstability has
 !--          already been taken account of via the TKE (cf. also Diss.).
-             IF ( prandtl_layer )  THEN
+             IF ( constant_flux_layer )  THEN
                 IF ( rif1d(nzb+1) >= 0.0_wp )  THEN
                    km1d(nzb+1) = us1d * kappa * zu(nzb+1) /                    &
@@ -805,5 +806,5 @@
 
        uv_total = SQRT( u1d(nzb+1)**2 + v1d(nzb+1)**2 )
-       IF ( ABS( v1d(nzb+1) ) .LT. 1.0E-5_wp )  THEN
+       IF ( ABS( v1d(nzb+1) ) < 1.0E-5_wp )  THEN
           alpha = ACOS( SIGN( 1.0_wp , u1d(nzb+1) ) )
        ELSE
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Call to init_surface_layer added. rif is replaced by ol and zeta.
 ! 
 ! Former revisions:
@@ -266,5 +266,8 @@
                sums_l_l, sums_up_fraction_l, sums_wsts_bc_l, ts_value,         &
                var_d, weight_pres, weight_substep 
-    
+ 
+    USE surface_layer_fluxes_mod,                                              &
+        ONLY:  init_surface_layer_fluxes
+   
     USE transpose_indices 
 
@@ -313,5 +316,5 @@
     ALLOCATE( ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng) )
 
-    ALLOCATE( rif(nysg:nyng,nxlg:nxrg), shf(nysg:nyng,nxlg:nxrg),     &
+    ALLOCATE( ol(nysg:nyng,nxlg:nxrg), shf(nysg:nyng,nxlg:nxrg),      &
               ts(nysg:nyng,nxlg:nxrg), tswst(nysg:nyng,nxlg:nxrg),    &
               us(nysg:nyng,nxlg:nxrg), usws(nysg:nyng,nxlg:nxrg),     &
@@ -714,6 +717,6 @@
              hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
 
-             IF ( prandtl_layer )  THEN
-                rif  = rif1d(nzb+1)
+             IF ( constant_flux_layer )  THEN
+                ol   = ( zu(nzb+1) - zw(nzb) ) / rif1d(nzb+1)
                 ts   = 0.0_wp  ! could actually be computed more accurately in the
                                ! 1D model. Update when opportunity arises.
@@ -723,5 +726,5 @@
              ELSE
                 ts   = 0.0_wp  ! must be set, because used in
-                rif  = 0.0_wp  ! flowste
+                ol   = ( zu(nzb+1) - zw(nzb) ) / zeta_min  ! flowste
                 us   = 0.0_wp
                 usws = 0.0_wp
@@ -731,5 +734,5 @@
           ELSE
              e    = 0.0_wp  ! must be set, because used in
-             rif  = 0.0_wp  ! flowste
+             ol   = ( zu(nzb+1) - zw(nzb) ) / zeta_min  ! flowste
              ts   = 0.0_wp
              us   = 0.0_wp
@@ -886,5 +889,5 @@
              e    = 0.0_wp
           ENDIF
-          rif   = 0.0_wp
+          ol    = ( zu(nzb+1) - zw(nzb) ) / zeta_min
           ts    = 0.0_wp
           us    = 0.0_wp
@@ -1095,5 +1098,5 @@
 !
 !--    Initialize Prandtl layer quantities
-       IF ( prandtl_layer )  THEN
+       IF ( constant_flux_layer )  THEN
 
           z0 = roughness_length
@@ -1103,5 +1106,5 @@
 !
 !--          Surface temperature is prescribed. Here the heat flux cannot be
-!--          simply estimated, because therefore rif, u* and theta* would have
+!--          simply estimated, because therefore ol, u* and theta* would have
 !--          to be computed by iteration. This is why the heat flux is assumed
 !--          to be zero before the first time step. It approaches its correct
@@ -1624,4 +1627,13 @@
        CALL location_message( 'initializing land surface model', .FALSE. )
        CALL init_lsm
+       CALL location_message( 'finished', .TRUE. )
+    ENDIF
+
+!
+!-- Initialize surface layer (done after LSM as roughness length are required
+!-- for initialization
+    IF ( constant_flux_layer )  THEN
+       CALL location_message( 'initializing surface layer', .FALSE. )
+       CALL init_surface_layer_fluxes
        CALL location_message( 'finished', .TRUE. )
     ENDIF
Index: palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1686)
+++ palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Removed typo
 ! 
 ! Former revisions:
@@ -117,5 +117,5 @@
     dpirho_l = 1.0_wp / pirho_l
 !
-!-- constant fot the sedimentation of cloud water (2-moment cloud physics)
+!-- constant for the sedimentation of cloud water (2-moment cloud physics)
     sed_qc_const = k_st * ( 3.0_wp / ( 4.0_wp * pi * rho_l )                   &
                           )**( 2.0_wp / 3.0_wp ) *                             &
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 1686)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Renamed prandtl_layer to constant_flux_layer.
 ! 
 ! Former revisions:
@@ -144,12 +144,13 @@
                building_length_y, building_wall_left, building_wall_south,     &
                canyon_height, canyon_wall_left, canyon_wall_south,             &
-               canyon_width_x, canyon_width_y, coupling_char, dp_level_ind_b,  &
-               dz, dz_max, dz_stretch_factor, dz_stretch_level,                &
-               dz_stretch_level_index, ibc_uv_b, io_blocks, io_group,          &
-               inflow_l, inflow_n, inflow_r, inflow_s, masking_method,         &
-               maximum_grid_level, message_string, momentum_advec, ocean,      &
-               outflow_l, outflow_n, outflow_r, outflow_s, prandtl_layer,      &
-               psolver, scalar_advec, topography, topography_grid_convention,  &
-               use_surface_fluxes, use_top_fluxes, wall_adjustment_factor 
+               canyon_width_x, canyon_width_y, constant_flux_layer,            &
+               coupling_char, dp_level_ind_b, dz, dz_max, dz_stretch_factor,   &
+               dz_stretch_level, dz_stretch_level_index, ibc_uv_b, io_blocks,  &
+               io_group, inflow_l, inflow_n, inflow_r, inflow_s,               &
+               masking_method, maximum_grid_level, message_string,             &
+               momentum_advec, ocean, outflow_l, outflow_n, outflow_r,         &
+               outflow_s, psolver, scalar_advec, topography,                   &
+               topography_grid_convention, use_surface_fluxes, use_top_fluxes, &
+               wall_adjustment_factor 
         
     USE grid_variables,                                                        &
@@ -477,5 +478,5 @@
 !-- Define vertical gridpoint from (or to) which on the usual finite difference
 !-- form (which does not use surface fluxes) is applied 
-    IF ( prandtl_layer  .OR.  use_surface_fluxes )  THEN
+    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
        nzb_diff = nzb + 2
     ELSE
@@ -955,5 +956,5 @@
 !-- the usual finite difference form (which does not use surface fluxes) is
 !-- applied 
-    IF ( prandtl_layer  .OR.  use_surface_fluxes )  THEN
+    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
        nzb_diff_u         = nzb_u_inner + 2
        nzb_diff_v         = nzb_v_inner + 2
